module Unification (
  UP,
  unify
  ) where
import CoreFP

type UP = [(Type, Type)]

tsubUP :: TSub -> UP -> UP
tsubUP s = map (\(l, r) -> (tsub s l, tsub s r))

unify :: UP -> TSub
unify eqs = go [] eqs
  where
    go mgu []       = mgu
    go mgu (eq:eqs) =
      go (mgu `tcomp` mgu') (eqs' ++ tsubUP mgu' eqs)
      where
        (eqs', mgu') = step eq
    step :: (Type, Type) -> (UP, TSub)
    step (s, t) | s == t      = ([], [])
    step (TVar x, t)          = singletonSub x t
    step (t, TVar x)          = singletonSub x t
    step (TCon g ss, TCon f ts) |
      g == f && length ss == length ts = (zip ss ts, [])
    step _                    = notUnif
    notUnif = error "not unifiable"
    singletonSub x t =
      if x `elem` tvars t then notUnif else ([], [(x, t)])
